//#include "main.h"
#include "psp.h"
#include "filer.h"

#define TITLE_COL ((31)|(26<<5)|(31<<10))
#define PATH_COL ((31)|(24<<5)|(28<<10))

#define FILE_COL ((20)|(20<<5)|(31<<10))
#define DIR_COL ((8)|(31<<5)|(8<<10))

#define SEL_COL ((30)|(30<<5)|(31<<10))
#define SELDIR_COL ((28)|(31<<5)|(28<<10))


#define INFOBAR_COL ((31)|(24<<5)|(20<<10))

#define MAXPATH 256		//temp, not confirmed
#define MAX_ENTRY 1024

u32 new_pad,old_pad;

enum { 
    TYPE_DIR=0x10, 
    TYPE_FILE=0x20 
}; 


char jpeg_files[MAX_ENTRY];
int nfiles;
SceIoDirent file;
SceIoDirent files[MAX_ENTRY];

extern int os9x_cpuclock;
extern char LaunchDir[256];

////////////////////////////////////////////////////////////////////////
// NCbN\[g
int cmpFile(SceIoDirent *a, SceIoDirent *b)
{
	char ca, cb;
	int i, n, ret;
	
	if(a->d_stat.st_attr==b->d_stat.st_attr){
		n=strlen(a->d_name);
		for(i=0; i<=n; i++){
			ca=a->d_name[i]; cb=b->d_name[i];
			if(ca>='a' && ca<='z') ca-=0x20;
			if(cb>='a' && cb<='z') cb-=0x20;
			
			ret = ca-cb;
			if(ret!=0) return ret;
		}
		return 0;
	}
	
	if(a->d_stat.st_attr & TYPE_DIR)	return -1;
	else					return 1;
}

void sort(SceIoDirent *a, int left, int right) {
	SceIoDirent tmp, pivot;
	int i, p;
	
	if (left < right) {
		pivot = a[left];
		p = left;
		for (i=left+1; i<=right; i++) {
			if (cmpFile(&a[i],&pivot)<0){
				p=p+1;
				tmp=a[p];
				a[p]=a[i];
				a[i]=tmp;
			}
		}
		a[left] = a[p];
		a[p] = pivot;
		sort(a, left, p-1);
		sort(a, p+1, right);
	}
}

// gqǗp
const struct {
	char *szExt;
	int nExtId;
} stExtentions[] = {        
    "zip",EXT_ZIP,
    "smc",EXT_SMC,
    "sfc",EXT_SFC,
    "fig",EXT_FIG,
    "bin",EXT_BIN,
    "1",EXT_1,
 		NULL, EXT_UNKNOWN
};

int getExtId(const char *szFilePath) {
	char *pszExt;
	int i;
	if((pszExt = strrchr(szFilePath, '.'))) {
		pszExt++;				
		for (i = 0; stExtentions[i].nExtId != EXT_UNKNOWN; i++) {
			if (!strcasecmp(stExtentions[i].szExt,pszExt)) {
				return stExtentions[i].nExtId;
			}
		}
	}
	return EXT_UNKNOWN;
}


char *find_file(char *pattern,char *path){
	int fd,found;	
	fd = sceIoDopen(path);
	found=0;	
	while(1){
		if(sceIoDread(fd, &file)<=0) break;
		if (strcasestr(file.d_name,pattern)) {found=1;break;}		
	}
	sceIoDclose(fd);
	if (found) return file.d_name;
	return NULL;
}

void getDir(const char *path) {
	int fd, b=0;
//	char *p;
	
	nfiles = 0;
			
	if(strcmp(path,"ms0:/")){		
		strcpy(files[nfiles].d_name,"..");
		files[nfiles].d_stat.st_attr = TYPE_DIR;
		nfiles++;
		b=1;
	}
		
	fd = sceIoDopen(path);
	if (fd<0){
		pgPrintAllBG(0,0,0xffff,"error while sceIoDopen");
		pgwaitPress();
		return ;
	}
	
	while(nfiles<MAX_ENTRY){
		if(sceIoDread(fd, &files[nfiles])<=0) break;
				
		if(files[nfiles].d_name[0] == '.') continue;
				
		if(files[nfiles].d_stat.st_attr == TYPE_DIR){
			strcat(files[nfiles].d_name, "/");
			nfiles++;
			continue;
		}
		if(getExtId(files[nfiles].d_name) != EXT_UNKNOWN) nfiles++;				
	}
		
	sceIoDclose(fd);
		
	if (nfiles) {
		if(b)
			sort(files+1, 0, nfiles-2);
		else
			sort(files, 0, nfiles-1);
	}
}

char LastPath[MAXPATH];
char FilerMsg[256];
char FileName[MAXPATH];

//int psp_ExitCheck(void);


int getFilePath(char *out,int can_exit) {
//    int counter=0;
	unsigned long color=RGB_WHITE;
	static int sel=0;
	int rows=26, top=0, x, y, h, i, /*len,*/ bMsg=0, up=0,pad_cnt=5;
	int pad;
	int retval;
	u16 *snes_image;
	int snesheight;
	int image_loaded=2;
	snes_image=(u16*)(0x44000000+512*272*2*2);					
	
	char path[MAXPATH], oldDir[MAXPATH], *p;
			
	strcpy(path, LastPath);

	if(FilerMsg[0])
		bMsg=1;
	
	
	getDir(path);
	
	memset(jpeg_files,1,MAX_ENTRY);
	
	if (out[0]) { //check if a file was already selected	
		for (i=0;i<nfiles;i++){			
			if (!strcmp(out,files[i].d_name)) {sel=i;break;}
		}		
	}
	
	pgDrawFrame(16,16,480-16,272-16,28|(28<<5)|(28<<10));
	
	while (get_pad()) pgWaitV();	
  old_pad=0;
	for(;;){       
		show_background(128+64);
    if (image_loaded==2) { //try new one
    	if ((files[sel].d_stat.st_attr == TYPE_FILE)&&(jpeg_files[sel])) {
				char filename [MAXPATH + 1];
				char drive [MAXPATH + 1];
				char dir [MAXPATH + 1];
				char fname [MAXPATH + 1];
				char ext [MAXPATH + 1];
				_splitpath (files[sel].d_name, drive, dir, fname, ext);
				sprintf(dir,"%sSAVES",LaunchDir);
				_makepath (filename, drive, dir, fname, ".jpg");
				if (!(image_loaded=os9x_loadsnap(filename,snes_image,&snesheight))) jpeg_files[sel]=0;				
			}
		} 
		
	  
    pgDrawFrame(12,12,480-12,272-12,28|(28<<5)|(28<<10));
    pgDrawFrame(11,11,480-11,272-11,30|(30<<5)|(30<<10));
    
		if (scePowerIsBatteryExist()){
			struct tm *tsys;
    	time_t cur_time;
			sceKernelLibcTime(&cur_time);
			tsys=localtime(&cur_time);
    	char bat_info[60],bat_time[16];
    	int batteryLifeTime = scePowerGetBatteryLifeTime();
    	if (batteryLifeTime>=0) sprintf(bat_time,"(%02dh%02dm)",batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));
    	else bat_time[0]=0;
    	sprintf(bat_info,"%02d%c%02d Bat.:%s%s%s%02d%%%s Tmp.%dC",
    	tsys->tm_hour,(tsys->tm_sec&1?':':' '),tsys->tm_min,
    	(scePowerIsPowerOnline()?"Plg.":""),
    	(scePowerIsBatteryCharging()?"Chrg.":""),
	    (scePowerIsLowBattery()?"Low!":""),
	    scePowerGetBatteryLifePercent(),
	    bat_time,
	    scePowerGetBatteryTemp());	    
	    mh_print(479-strlen(bat_info)*5,0,bat_info,(22<<0)|(31<<5)|(22<<10));
		}
       
       
    new_pad=0;
    if (!pad_cnt) new_pad=get_pad();
    else pad_cnt--;
    pgWaitV();
        
		if (new_pad) {
			bMsg=0;				
			if (old_pad==new_pad) pad_cnt=2;
			else pad_cnt=6;
		 	old_pad=new_pad;
		 
		}
        
				
        
		if(new_pad & PSP_CTRL_CIRCLE){
			if(files[sel].d_stat.st_attr == TYPE_DIR){
				if(!strcmp(files[sel].d_name,"..")){  up=1; }
                else{
					strcat(path,files[sel].d_name);
					getDir(path);					
					sel=0;
					while (get_pad()) pgWaitV();	
				}
			}else{
						strcpy(out, path);
						strcat(out, files[sel].d_name);
						strcpy(LastPath,path);
				
						retval= 1;				
						break;
			 }
			}		
        else if(new_pad & PSP_CTRL_CROSS)   { if (can_exit) {retval= 0;break;} }
        else if(new_pad & PSP_CTRL_TRIANGLE){ up=1;     }
        else if(new_pad & PSP_CTRL_UP)      { sel--;image_loaded=2;    }
        else if(new_pad & PSP_CTRL_DOWN)    { sel++;image_loaded=2;    }
        else if(new_pad & PSP_CTRL_LEFT)    { sel-=10;if (sel<0) sel=0;image_loaded=2; }
        else if(new_pad & PSP_CTRL_RIGHT)   { sel+=10;if(sel >= nfiles) sel=nfiles-1;image_loaded=2;  }
        /*else if(new_pad & PSP_CTRL_RTRIGGER) {
        		if (os9x_cpuclock==222) os9x_cpuclock=266;
        		else if (os9x_cpuclock==266) os9x_cpuclock=333;
        		else os9x_cpuclock=222;
        }*/
		
		if(up){
			if(strcmp(path,"ms0:/")){
				p=strrchr(path,'/');
				*p=0;
				p=strrchr(path,'/');
				p++;
				strcpy(oldDir,p);
				strcat(oldDir,"/");
				*p=0;
				getDir(path);
				
				sel=0;
				for(i=0; i<nfiles; i++) {
					if(!strcmp(oldDir, files[i].d_name)) {
						sel=i;
						top=sel-3;
						break;
					}
				}
			}
			up=0;
		}
		
		
		
		if(top > nfiles-rows)	top=nfiles-rows;
		if(top < 0)				top=0;
		if(sel >= nfiles)		sel=0;
		if(sel < 0)				sel=nfiles-1;
		if(sel >= top+rows)		top=sel-rows+1;
		if(sel < top)			top=sel;
		
        if(bMsg) {
          //pgPrint(1,0,TITLE_COL,FilerMsg);
          mh_print(1,0,FilerMsg,TITLE_COL);
          //pgPrint(0,33,INFOBAR_COL,"\1 OK \2 CANCEL \4 Parent dir.          \5,\7,\6,\b to browse list");
//			rin_frame(FilerMsg,"FOK@~FCANCEL@FUP");
        }
        else {
          //pgPrint(1,0,PATH_COL,path);          
          mh_print(8,0,path,PATH_COL);
          //pgPrint(0,33,INFOBAR_COL,"\1 OK \2 CANCEL \4 Parent dir.           \5,\7,\6,\b to browse list");
//			rin_frame(path,"FOK@~FCANCEL@FUP");
        }
        //pgPrintDecTrim(54,0,TITLE_COL,os9x_cpuclock);
        //pgPrint(57,0,TITLE_COL,"Mhz");
        if (can_exit) pgPrint(1,33,INFOBAR_COL,"\1 RUN \2 BACK TO GAME \4 Parent dir.  \5,\7,\6,\b to browse list");
        else 					pgPrint(1,33,INFOBAR_COL,"\1 RUN \4 Parent dir.                  \5,\7,\6,\b to browse list");

		// XN[o[
		if(nfiles > rows){
			h = 219;
			pgDrawFrame(445,25,446,243,(0xd<<0)|(0xd<<5)|(0x17<<10));
			pgFillBox(448, h*top/nfiles + 25,460, h*(top+rows)/nfiles + 25,
				(0xd<<0)|(0xd<<5)|(0x17<<10));
			pgFillBox(448+1, h*top/nfiles + 25+1,460-1, h*(top+rows)/nfiles + 25 -1,
				(0x17<<0)|(0x17<<5)|(0x1f<<10));

		}
		
		x=3; y=4;
		for(i=0; i<rows; i++){
			if(top+i >= nfiles) break;
			if(top+i == sel) color = SEL_COL;
			else			 color = FILE_COL;
			if (files[top+i].d_stat.st_attr==TYPE_DIR){
				if (color==SEL_COL) color=SELDIR_COL;
				else color = DIR_COL;
			}
//			if(top+i == sel) color = setting.color[2];
//			else			 color = setting.color[3];
			if ((color==SEL_COL)||(color==SELDIR_COL)) pgPrintSel(x, y, color, files[top+i].d_name);
			else pgPrint(x, y, color, files[top+i].d_name);
			y+=1;
		}
		
//        counter++;
//        pgPrintBGHex(0,10,0x7fff,counter);
//        pgPrintBGHex(0,11,0x7fff,up);

		if (image_loaded==1) { //jpeg already loaded
			int x,y,xmax=128,ymax=snesheight/2;
			u16 *dst=pgGetVramAddr(0,0);
			for (y=0;y<ymax;y++)
				for (x=0;x<xmax;x++) {
					int col1=dst[(y+272-ymax-12)*512+x+480-xmax-12];
					int col2a=snes_image[(y*2)*256+(x*2)];
					int col2b=snes_image[(y*2+1)*256+(x*2)];
					int col2c=snes_image[(y*2)*256+(x*2+1)];
					int col2d=snes_image[(y*2+1)*256+(x*2+1)];					
					int col2;
					col2=((((((col2a>>10)&31)+((col2b>>10)&31)+((col2c>>10)&31)+((col2d>>10)&31))>>2)*2/3)<<10);
					col2|=((((((col2a>>5)&31)+((col2b>>5)&31)+((col2c>>5)&31)+((col2d>>5)&31))>>2)*2/3)<<5);
					col2|=((((((col2a>>0)&31)+((col2b>>0)&31)+((col2c>>0)&31)+((col2d>>0)&31))>>2)*2/3)<<0);
					//int col2=snes_image[y*256+x];
					int r1,g1,b1,r2,g2,b2;
					b1=(col1>>10)&31;g1=(col1>>5)&31;r1=(col1>>0)&31;
					b2=(col2>>10)&31;g2=(col2>>5)&31;r2=(col2>>0)&31;
					b1=b1/3+b2; if (b1>31) b1=31;
					g1=g1/3+g2; if (g1>31) g1=31;
					r1=r1/3+r2; if (r1>31) r1=31;
												
					dst[(y+272-ymax-12)*512+x+480-xmax-12]=(b1<<10)|(g1<<5)|(r1);
				}
			pgDrawFrame(480-xmax-12-2,272-ymax-12-2,480-12,272-12,28|(28<<5)|(28<<10));
		  pgDrawFrame(480-xmax-12-1,272-ymax-12-1,480-12,272-12,30|(30<<5)|(30<<10));
		}

		pgScreenFlipV();

        /*if(psp_ExitCheck()) {
            retval= -1;
        }*/
	}
	
	while (get_pad()) pgWaitV();	
	return retval;
}


int InitFiler(char*msg,char*path)
{
    strcpy(FilerMsg,msg);
    strcpy(LastPath,path);
    memset(files,0,sizeof(files));
    return 1;
}
