//#define __DEBUG_SNES_
//#define __DEBUG__ROM__ "ms0:/PSP/GAME/snes9xTYL/ROMS/Tales of Phantasia (F).zip"
//#define DEBUG_SAVE_SLOT ".za0"

/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2002 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2001 - 2004 John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2004 Brad Jorsch (anomie@users.sourceforge.net),
                            funkyass (funkyass@spam.shaw.ca),
                            Joel Yliluoma (http://iki.fi/bisqwit/)
                            Kris Bleakley (codeviolation@hotmail.com),
                            Matthew Kendora,
                            Nach (n-a-c-h@users.sourceforge.net),
                            Peter Bortas (peter@bortas.org) and
                            zones (kasumitokoduck@yahoo.com)

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and Nach

  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2004 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman, neviksti (neviksti@hotmail.com),
                            Kris Bleakley, Andreas Naive

  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2004 zsKnight, pagefault (pagefault@zsnes.com) and
                            Kris Bleakley
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-DD1 C emulator code
  (c) Copyright 2003 Brad Jorsch with research by
                     Andreas Naive and John Weidman
 
  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  ST010 C++ emulator code
  (c) Copyright 2003 Feather, Kris Bleakley, John Weidman and Matthew Kendora

  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar, Gary Henderson and John Weidman


  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004 Marcus Comstedt (marcus@mc.pp.se) 

 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "snes9x.h"
#include "memmap.h"
#include "debug.h"
#include "cpuexec.h"
#include "ppu.h"
#include "snapshot.h"
#include "apu.h"
#include "display.h"
#include "gfx.h"
#include "soundux.h"
#include "spc700.h"
//#include "spc7110.h"


#include "psp/psp.h"
#include "psp/filer.h"
#include "psp/menu.h"
#include "psp/imageio.h"
#include "psp/blitter.h"

#include <pspaudio.h>

/* Define the module info section */
PSP_MODULE_INFO("snes9xTYL", 0, 0, 1);

/* Define the main thread's attribute value (optional) */
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

extern "C" {


#include "img_jpeg.h"	

#include "message.c"	


void msgBox(char *msg);
	
unsigned int __attribute__((aligned(16))) list[262144];
u16 *clut256;
//u16 __attribute__((aligned(16))) clut256[256*3];

int swap_buf;
volatile int bypass_loadsettings=0;

static struct timeval next1 = { 0, 0 };

char *os9x_shortfilename(char *filename);

extern void image_put(int x0,int y0,IMAGE* img,int fade);

int os9x_load(const char *ext);
int os9x_save(const char *ext);
}

const char *S9xGetSaveFilename( const char *e );


char str_tmp[256];
char LaunchDir[256];
char romPath[256];
char lastRom[256];

IMAGE* bg_img;

u16 os9x_savestate_mini[128*120];

void InitSoundThread();
void StopSoundThread();



#include "gammatab.h"

#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11
#define MAX_AUTO_SKIP 5

int psp_vsync;
int os9x_renderingpass,os9x_snesheight;

int os9x_BG0,os9x_BG1,os9x_BG2,os9x_BG3,os9x_OBJ,os9x_easy;

int os9x_analog_mode;
int os9x_newrom=0;
int os9x_showfps;
int os9x_padvalue,os9x_padvalue_ax,os9x_padvalue_ay;

int os9x_cpuclock;
uint32 os9x_ColorsChanged;
uint32 os9x_gammavalue;
int os9x_fastsprite;
int32 os9x_ShowSub;
int os9x_render;
int os9x_softrendering,os9x_smoothing;
int os9x_specialskipframe;
int os9x_fskipvalue;
int os9x_CyclesPercentage;
int os9x_apuenabled;
int os9x_DisableHDMA;
int os9x_DisableIRQ;
int os9x_speedlimit;

int os9x_sndfreq;

char rom_filename[256];
char shortrom_filename[64];

int g_bSleep;
int in_emu;

/*******************************/

static struct timeval	s_tvStart;
static int				s_iFrame;
int				s_TotalFrame;
static int				s_iFlip = 0;

volatile int os9x_paused=0;
volatile int			g_bLoop = true;
volatile int				g_thread = -1;

static int current_SoundBuffer=0;
static u32 snd_freqratio,snd_freqerr;
static uint16 __attribute__((aligned(16))) SoundBuffer[3][MAX_BUFFER_SIZE];



static uint8 __attribute__((aligned(16))) 	GFX_SubScreen[SNES_WIDTH * SNES_HEIGHT_EXTENDED * 2];
static uint8 __attribute__((aligned(16))) 	GFX_ZBuffer[SNES_WIDTH * SNES_HEIGHT_EXTENDED * 2];
static uint8 __attribute__((aligned(16))) 	GFX_SubZBuffer[SNES_WIDTH * SNES_HEIGHT_EXTENDED * 2];


#define timercmp(a, b, CMP)	(((a)->tv_sec == (b)->tv_sec) ? ((a)->tv_usec CMP (b)->tv_usec) : ((a)->tv_sec CMP (b)->tv_sec))


void S9xCloseSoundDevice();

extern "C"{
int psp_ExitCheck(){
	return !g_bLoop;
}

void update_pad(){
	SceCtrlData	ctl;	
	//sceCtrlReadBufferPositive( &ctl, 1 );
	sceCtrlPeekBufferPositive( &ctl, 1 );
	os9x_padvalue=ctl.Buttons;
	os9x_padvalue_ax=ctl.Lx;
	os9x_padvalue_ay=ctl.Ly;				
}


int ExitCallback(int arg1, int arg2, void *common){
	// Cleanup the games resources etc (if required)
	//debug_log("Exit Callback");
	
	save_settings();
			
	scePowerSetClockFrequency(222,222,111);			
	
	Settings.Paused = TRUE;	
	if (in_emu){
		Memory.SaveSRAM( (char*)S9xGetSaveFilename(".SRM") );
		pgWaitVn(180);
  	}
	
	StopSoundThread();		
	
	S9xCloseSoundDevice();
	g_bLoop = false;
	// Exit game
	sceKernelExitGame();
	return 1;
}
}
int PowerCallback(int unknown, int pwrflags,void *common){
	//debug_log("Power Callback");
	if (pwrflags & PSP_POWER_CB_HOLD_SWITCH) {
		//can be used for any purpose, debugging, profiling,...		
	}
	
	if ((pwrflags & PSP_POWER_CB_POWER_SWITCH) || (pwrflags & PSP_POWER_CB_SUSPENDING)) {
		g_bSleep=1;		
		StopSoundThread();
		scePowerSetClockFrequency(222,222,111);
		Settings.Paused = TRUE;
		if (in_emu){
			Memory.SaveSRAM( (char*)S9xGetSaveFilename(".SRM") );
		}
	}else if(pwrflags & PSP_POWER_CB_RESUME_COMPLETE){
		g_bSleep=0;
		Settings.Paused=false;		
	}	
	int cbid = sceKernelCreateCallback("Power Callback", PowerCallback,NULL);
	scePowerRegisterCallback(0, cbid);
	
	return 0;
}

// Thread to create the callbacks and then begin polling
int CallbackThread(SceSize args, void *argp){
	int cbid;
	cbid = sceKernelCreateCallback( "Exit Callback",  ExitCallback,NULL );
	sceKernelRegisterExitCallback( cbid );
	cbid = sceKernelCreateCallback( "Power Callback",  PowerCallback,NULL );
	scePowerRegisterCallback( 0, cbid );
	sceKernelSleepThreadCB();
	return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks()
{
	int thid = 0;

	thid = sceKernelCreateThread( "update_thread", CallbackThread, 0x11, 0xFA0, /*THREAD_ATTR_USER*/0, 0 );
	if( thid >= 0 ){
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}

void set_cpu_clock(){
		switch (os9x_cpuclock){
			case 266:scePowerSetClockFrequency(266,266,133);break;
			case 333:scePowerSetClockFrequency(333,333,166);break;
			default :scePowerSetClockFrequency(222,222,111);
		}
}


extern "C" {

void debug_log( const char* message ){
#ifndef RELEASE
	static int	sy = 1;

	pgPrintAllBG( SNES_WIDTH / 8, sy, 0xffff, message );
	sy++;

	if ( sy >= CMAX_Y ){
		int 	x, y;
		uint16*	dest;

		dest = (uint16*)pgGetVramAddr( SNES_WIDTH, 0 );

		for ( y = 0; y < SCREEN_HEIGHT; y++ ){
			for ( x = 0; x < (SCREEN_WIDTH - SNES_WIDTH); x++ ){
				*dest++ = 0;
			}
			dest += (512 - (SCREEN_WIDTH - SNES_WIDTH));
		}
		sy = 1;
	}
#endif // RELEASE
}

void debug_int( const char* message, int value ){
	strcpy( String, message );
	format_int( &String[strlen( String )], value );

	debug_log( String );
}

void debug_hex( int value ){
	int		shift;
	int		val;
	int		i;

	shift = 28;
	for ( i = 0; i < 8; i++ ){
		val = (value >> shift) & 0x0f;
		if ( val < 10 ){
			String[i] = val + '0';
		} else {
			String[i] = val - 10 + 'A';
		}
		shift -= 4;
	}
	String[i] = 0;

	debug_log( String );
}
	
};

//
// C++ Language
//

void S9xInitCheatData()
{
}

void S9xApplyCheat( uint32 which1 )
{
}

void S9xApplyCheats()
{
}

bool8 S9xLoadCheatFile( const char *filename )
{
	return FALSE;
}

void S9xAutoSaveSRAM() {
//	Memory.SaveSRAM ((char*)S9xGetSaveFilename(".SRM"));
}

bool8 S9xOpenSoundDevice( int mode, bool8 stereo, int buffer_size )
{
	so.mute_sound  = TRUE;
	if ( buffer_size <= 0 ){
		return FALSE;
	}


	so.sound_switch = 255;
	so.stereo       = TRUE;
	so.sixteen_bit  = TRUE;

	so.buffer_size  = buffer_size;
	so.encoded      = FALSE;
		
	// Initialize channel and allocate buffer
	so.sound_fd = sceAudioChReserve( -1, buffer_size, 0 );
	if ( so.sound_fd < 0 ){
		return FALSE;
	}

	if ( so.stereo ){
		so.buffer_size *= 2;
	}
	if ( so.sixteen_bit ){
		so.buffer_size *= 2;
	}

	if ( so.buffer_size > MAX_BUFFER_SIZE ){
		so.buffer_size = MAX_BUFFER_SIZE;
	}
	
	current_SoundBuffer = 0;	
	S9xSetPlaybackRate( Settings.SoundPlaybackRate  );
		
	so.mute_sound  = FALSE;

	return TRUE;
}

void S9xCloseSoundDevice()
{
	if ( so.sound_fd >= 0 ){
		sceAudioChRelease( so.sound_fd );
		so.sound_fd = -1;
	}
}

//
// C Language
//

void S9xMessage( int type, int number, const char* message ){
	
	debug_log( message );
	S9xSetInfoString( message );
	if ((type==-1)||(type==S9X_ERROR)) pgwaitPress();
}

void S9xMovieUpdate (){
}


bool8 S9xReadSuperScopePosition (int &x, int &y, uint32 &buttons)
{
	return FALSE;
}

bool8 S9xReadMousePosition (int which, int &x, int &y, uint32 &buttons)
{
	return FALSE;
}

void S9xLoadSDD1Data()
{
}

uint32 S9xReadJoypad( int which1 )
{
	
	uint32		ret;
	if ( which1 ){
		return 0;
	}
	
	if (!os9x_analog_mode) {
		ret = ((os9x_padvalue & PSP_CTRL_UP)       << 7) |	// 
		  ((os9x_padvalue & PSP_CTRL_DOWN)     << 4) |	// 
		  ((os9x_padvalue & PSP_CTRL_LEFT)     << 2) |	// 
		  ((os9x_padvalue & PSP_CTRL_RIGHT)    << 3) ;	// 
	}
	else {
		int temp=0;		
		if (os9x_padvalue_ax<0x30) temp|=PSP_CTRL_LEFT;
		if (os9x_padvalue_ax>0xA0) temp|=PSP_CTRL_RIGHT;
		if (os9x_padvalue_ay<0x30) temp|=PSP_CTRL_UP;
		if (os9x_padvalue_ay>0xA0) temp|=PSP_CTRL_DOWN;
		ret = ((temp & PSP_CTRL_UP)       << 7) |	// 
		  ((temp & PSP_CTRL_DOWN)     << 4) |	// 
		  ((temp & PSP_CTRL_LEFT)     << 2) |	// 
		  ((temp & PSP_CTRL_RIGHT)    << 3) ;	// 
	}
	
	ret|=((os9x_padvalue & PSP_CTRL_CIRCLE)   >> 6) |	//  -> `
		  ((os9x_padvalue & PSP_CTRL_CROSS)    << 1) |	// ~ -> a
		  ((os9x_padvalue & PSP_CTRL_SQUARE)   >> 1) |	//  -> x
		  ((os9x_padvalue & PSP_CTRL_TRIANGLE) >> 6) |	//  -> w
		  ((os9x_padvalue & PSP_CTRL_LTRIGGER) >> 3) |	// k
		  ((os9x_padvalue & PSP_CTRL_RTRIGGER) >> 5) |	// q
		  ((os9x_padvalue & PSP_CTRL_START)    << 9) |	// rs`qs
		  ((os9x_padvalue & PSP_CTRL_SELECT)   << 13);	// rdkdbs
/*
	     X		@
	Y @ A		@
	  B 			@~

SNES_TR			0x0010
SNES_TL			0x0020
SNES_X			0x0040
SNES_A			0x0080
SNES_RIGHT		0x0100
SNES_LEFT		0x0200
SNES_DOWN		0x0400
SNES_UP			0x0800
SNES_START		0x1000
SNES_SELECT		0x2000
SNES_Y			0x4000
SNES_B			0x8000

PSP_SQUARE		0x8000
PSP_TRIANGLE	0x1000
PSP_CIRCLE		0x2000
PSP_CROSS		0x4000
PSP_UP			0x0010
PSP_DOWN		0x0040
PSP_LEFT		0x0080
PSP_RIGHT		0x0020
PSP_START		0x0008
PSP_SELECT		0x0001
PSP_LTRIGGER	0x0100
PSP_RTRIGGER	0x0200
*/

	return ret | 0x80000000;
}

void S9xSetPalette()
{
}

#define MAXVOLUME	0x8000


int S9xProcessSound (SceSize ,void *) {
//debug_log( "Thread start!" );
	do {
		int i;
		u32 sample_count=so.buffer_size>>1;
		u32 *src,*dst;
		
		if ((os9x_apuenabled==2)&&(!os9x_paused)) {
			src=(u32*)SoundBuffer[2];
	  	dst=(u32*)SoundBuffer[current_SoundBuffer];  	
	  	
	  	//snd_freqratio=1<<16;
	  	
			if (snd_freqratio==(1<<16)) { // 1/1
	  		S9xMixSamplesO((uint8*)SoundBuffer[current_SoundBuffer],sample_count,0);//stereo & 16bits  		
	  	} /*else if (snd_freqratio==(1<<15)) { // 1/2	  		
	  		S9xMixSamplesO((uint8*)SoundBuffer[2],sample_count>>1,0);//stereo & 16bits
	  		for (i=sample_count>>2;i;i--) {
	  			*dst++=*src;
	  			*dst++=*src++;
	  		}
	  	}*/ else { //generic case, missing some real interpolation 
	  		S9xMixSamplesO((uint8*)SoundBuffer[2],(sample_count*snd_freqratio)>>16,0);//stereo & 16bits
	  		for (i=sample_count>>1;i;i--) {
	  			*dst++=*src;
	  			snd_freqerr+=snd_freqratio;
	  			if (snd_freqerr&(1<<16)) {
		  			snd_freqerr&=(1<<16)-1;
	  				src++;
	  			}
	  		}
	  	}
  	}
  	else memset((char*)SoundBuffer[current_SoundBuffer],0,sample_count*2);
  	
  	sceAudioOutputPannedBlocking( so.sound_fd, MAXVOLUME, MAXVOLUME, (char*)SoundBuffer[current_SoundBuffer]);
  	current_SoundBuffer^=1;
    } while (Settings.ThreadSound);
	  //debug_log( "Thread end" );

    return (0);
}

void InitSoundThread(){
	//if (os9x_apuenabled<2) return;
	if (g_thread!=-1) return;
	//debug_log( "Create Thread" );
	g_thread = sceKernelCreateThread( "sound thread", (SceKernelThreadEntry)S9xProcessSound, 0x8, 0x40000, /*THREAD_ATTR_USER*/0, 0 );
	if ( g_thread < 0 ){
		debug_log( "Thread failed" );
		return;
	}
	Settings.SoundPlaybackRate = os9x_sndfreq;
	snd_freqratio = (u32)(Settings.SoundPlaybackRate)*(1<<16) / 44100;
	snd_freqerr=0;
	current_SoundBuffer=0;
	S9xSetPlaybackRate( Settings.SoundPlaybackRate  );
	
	Settings.ThreadSound = true;
	sceKernelStartThread( g_thread, 0, 0 );
	//debug_log( "Thread ok" );
}

void StopSoundThread(){
	//if (os9x_apuenabled<2) return; //not  needed since g_thread will be -1
	if ( g_thread !=-1 ){		
		Settings.ThreadSound = false;
		sceKernelWaitThreadEnd( g_thread, NULL );
		sceKernelDeleteThread( g_thread );
		g_thread=-1;
	}
}


void S9xSyncSpeed()
{
	static int waited=1;
	static int cpt;				
	struct timeval now;
	
	cpt++;
	if (cpt&1) update_pad();
	
	s_iFrame++;
	s_TotalFrame++;

	S9xProcessEvents( FALSE );

	sceKernelLibcGettimeofday( &now, 0 );
	if ( next1.tv_sec == 0 ){
		next1 = now;
		++next1.tv_usec;	
	}
	
	if ( Settings.TurboMode ){
		if( ++IPPU.FrameSkip >= Settings.TurboSkipFrames ){
			IPPU.FrameSkip = 0;
			IPPU.SkippedFrames = 0;
			IPPU.RenderThisFrame = TRUE;
		} else {
			++IPPU.SkippedFrames;
			IPPU.RenderThisFrame = FALSE;
		}
		return;
	}
	
	if (os9x_speedlimit){
		waited=0;
	  if ( timercmp( &next1, &now, < ) ){
			unsigned int lag;
			lag = (now.tv_sec - next1.tv_sec) * 1000000 + now.tv_usec - next1.tv_usec;
			if ( lag >= 1000000 ){
				next1 = now;				
			}			
	  }		
	    	    			
	  while ( timercmp( &next1, &now, > ) ){
			sceKernelLibcGettimeofday( &now, 0 );
			waited=1;
	  }
	  next1.tv_usec += ((Settings.PAL?1000000/50:1000000/60));
	  if ( next1.tv_usec >= 1000000 ){
	  	next1.tv_sec += next1.tv_usec / 1000000;
      next1.tv_usec %= 1000000;
	  }	
	}
				
	if (Settings.SkipFrames==AUTO_FRAMERATE){
		if (!waited && (IPPU.SkippedFrames<MAX_AUTO_SKIP) ) {			
			IPPU.RenderThisFrame=0;
			IPPU.SkippedFrames++;			
		} else {
			IPPU.RenderThisFrame=1;
			IPPU.SkippedFrames=0;
		}
	}else{
		IPPU.RenderThisFrame = ++IPPU.SkippedFrames > Settings.SkipFrames;
		if ( IPPU.RenderThisFrame ) IPPU.SkippedFrames = 0;
	}
	
	
}


const char *S9xGetFilename( const char *e )
{
	static char filename [_MAX_PATH + 1];
	char drive [_MAX_DRIVE + 1];
	char dir [_MAX_DIR + 1];
	char fname [_MAX_FNAME + 1];
	char ext [_MAX_EXT + 1];

	_splitpath (Memory.ROMFilename, drive, dir, fname, ext);
	_makepath (filename, drive, dir, fname, e);

	return (filename);
}

const char *S9xGetSaveFilename( const char *e ) {
	static char filename [_MAX_PATH + 1];
	char drive [_MAX_DRIVE + 1];
	char dir [_MAX_DIR + 1];
	char fname [_MAX_FNAME + 1];
	char ext [_MAX_EXT + 1];

	_splitpath (Memory.ROMFilename, drive, dir, fname, ext);
	sprintf(dir,"%sSAVES",LaunchDir);
	_makepath (filename, drive, dir, fname, e);	
		
	return (filename);
}


bool8 S9xInitUpdate() {	  	
	os9x_renderingpass=0;
	
	if (os9x_softrendering>=2) {//GU mode
		sceGuStart(0,list);
		
		
				
		/* setup view port */
		//sceGuOffset(2048 - (256/2),2048 - (240/2));
		//sceGuViewport(2048,2048,256,240);
		sceGuDrawBufferList(GU_PSM_5551,(void*)(512*272*2*2+256*240*4+2*256*256*2),256);
						
		/*clear screen */
		sceGuScissor(0,0,256,os9x_snesheight);		
		sceGuClearColor(0);
		//sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT/*|GU_DEPTH_BUFFER_BIT*/);
				
		sceGuFinish();
  	sceGuSync(0,0);
  	  	  	
	}
	
	return TRUE;
}



void resync_var(){
		os9x_specialskipframe=0;
    if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
    else if (os9x_fskipvalue==SKEEZIX_FSKIP) {
    	Settings.SkipFrames=0;
    	os9x_specialskipframe=1;
    }
    else Settings.SkipFrames=os9x_fskipvalue;
		Settings.NextAPUEnabled = Settings.APUEnabled = os9x_apuenabled;
		if (os9x_apuenabled==2){
			S9xSetSoundMute( false );
		 } else S9xSetSoundMute( true );
		 		
}


void before_pause(){
	//blit_shutdown();
	StopSoundThread();
	os9x_paused=1;
	
	scePowerSetClockFrequency(222,222,111);
	Settings.Paused = TRUE;			
	
}
void after_pause(){
	update_pad();
		
	pgFillAllvram(0);
	
	Settings.Paused = false;	
				
	resync_var();
									
	set_cpu_clock();
	InitSoundThread();
	os9x_paused=0;
		
	/*reinit blitter*/		
	blit_reinit();						
		
	/*invalidate all cache*/
	ZeroMemory (IPPU.TileCached [TILE_2BIT], MAX_2BIT_TILES<<1);
  ZeroMemory (IPPU.TileCached [TILE_4BIT], MAX_4BIT_TILES<<1);
  ZeroMemory (IPPU.TileCached [TILE_8BIT], MAX_8BIT_TILES<<1);
    
  tile_askforreset(-1);
  /**/
	sceKernelLibcGettimeofday( &s_tvStart, 0 );
	next1.tv_sec = next1.tv_usec = 0;
}

bool8 S9xDeinitUpdate (int Width, int Height, bool8 sixteen_bit) {		
	char			buf[128];
	struct timeval	now;
	unsigned int	diff;

	//s_iFrame++;
	sceKernelLibcGettimeofday( &now, 0 );
	
	if (os9x_softrendering>=2) {
		switch (os9x_render) {
			case 0: 
  						//could be faster since no stretch, use copyimage
  						guDrawBuffer((u16*)(0x44000000+512*272*2*2+256*240*4+2*256*256*2),256,os9x_snesheight,256,256,os9x_snesheight);
  						break;
			case 1:	
							guDrawBuffer((u16*)(0x44000000+512*272*2*2+256*240*4+2*256*256*2),256,os9x_snesheight,256,256*272/os9x_snesheight,272);
				break;
			case 2:	
							guDrawBuffer((u16*)(0x44000000+512*272*2*2+256*240*4+2*256*256*2),256,os9x_snesheight,256,320*272/os9x_snesheight,272);
				break;
			case 3:	
							guDrawBuffer((u16*)(0x44000000+512*272*2*2+256*240*4+2*256*256*2),256,os9x_snesheight,256,480,272);
				break;
		}								
  } else {
		switch (os9x_render) {
			case 0:
				//could be faster since no stretch, use copyimage
				guDrawBuffer((u16*)(GFX.Screen),256,os9x_snesheight,256,256,os9x_snesheight);			
				break;
			case 1:	guDrawBuffer((u16*)(GFX.Screen),256,os9x_snesheight,256,256*272/os9x_snesheight,272);
				break;
			case 2:	guDrawBuffer((u16*)(GFX.Screen),256,os9x_snesheight,256,320*272/os9x_snesheight,272);
				break;
			case 3:	guDrawBuffer((u16*)(GFX.Screen),256,os9x_snesheight,256,480,272);
				break;
		}
	}
	
	if (os9x_showfps) {
		diff  = (now.tv_sec - s_tvStart.tv_sec) * 1000000 + now.tv_usec - s_tvStart.tv_usec;
		diff /= 1000000;
		if ( diff ) {
			buf[0] = ((s_iFrame / diff) / 100) + '0';
			buf[1] = (((s_iFrame / diff) / 10)%10) + '0';
			buf[2] = ((s_iFrame / diff) % 10) + '0';
			buf[3] = 'F';
			buf[4] = 'P';
			buf[5] = 'S';
			buf[6] = '\0';

			pgPrintBG( CMAX_X - 7, 0, 0xffff, buf );

			s_tvStart = now;
			s_iFrame  = 0;				
		}
#ifndef RELEASE		
		sprintf(buf,"%03d",os9x_renderingpass);
		pgPrintAllBG(CMAX_X-8-strlen(buf),0,0xffff,buf);
#endif		
		os9x_renderingpass=0;
  }
	
	
	return TRUE;
}


void S9xInitDisplay(  )
{
//	Settings.Transparency = TRUE;
#ifndef OPTI
	Settings.SixteenBit   = TRUE;
#endif // OPTI
	Settings.SupportHiRes = 0; //interpolate;
	
	memset( GFX_SubScreen,  0, SNES_WIDTH * SNES_HEIGHT_EXTENDED * 2 );
	memset( GFX_ZBuffer,    0, SNES_WIDTH * SNES_HEIGHT_EXTENDED  );
	memset( GFX_SubZBuffer, 0, SNES_WIDTH * SNES_HEIGHT_EXTENDED  );

	GFX.Pitch      = 256 * 2;
	//screen & zbuffer share the same memory location since they should not be used
	//at the same time for the same location
  GFX.Screen   = (uint8*)(0x44000000+512*272*2*2);
  
	GFX.SubScreen  = (uint8*)GFX_SubScreen;
	GFX.ZBuffer    = (uint8*)GFX_ZBuffer;
	GFX.SubZBuffer = (uint8*)GFX_SubZBuffer;
}

void S9xInitInputDevices()
{
}

void S9xProcessEvents( bool8 block ) {
	if (((!os9x_analog_mode)&&(os9x_padvalue_ax < 0x30))|| ((os9x_analog_mode)&&(os9x_padvalue&PSP_CTRL_LEFT))) {			
		before_pause();
		showmenu();				
		after_pause();
	}
	
	if (((!os9x_analog_mode&&(os9x_padvalue_ax > 0xD0))) || ((os9x_analog_mode&&(os9x_padvalue&PSP_CTRL_RIGHT)))) Settings.TurboMode=1;
	else Settings.TurboMode=0;
}


void S9xExit (){
	ExitCallback(0,0,NULL);
}

const char *S9xBasename (const char *f)
{
  const char *p;
  if ((p = strrchr (f, '/')) != NULL || (p = strrchr (f, '\\')) != NULL)
    return (p + 1);
  return (f);
}

bool8 S9xOpenSnapshotFile (const char *fname, bool8 read_only, STREAM *file) {
  if (read_only) {    	
      if (!(*file = OPEN_STREAM(fname,"rb"))) return(false);
	} else {		
    if (!(*file = OPEN_STREAM(fname,"wb"))) return(false);
	}
  
  if (read_only) {//reading savestate
		READ_STREAM(os9x_savestate_mini,128*120*2,*file);
	} else { //writing savestate
		int x,y;
		u16 *snes_image;
		if (os9x_softrendering<2)	snes_image=(u16*)(0x44000000+512*272*2*2);
		else snes_image=(u16*)(0x44000000+2*512*272*2+256*240*4+2*256*256*2);
		for (y=0;y<os9x_snesheight/2;y++)
			for (x=0;x<128;x++) {
				int col2a=snes_image[(y*2)*256+(x*2)];
				int col2b=snes_image[(y*2+1)*256+(x*2)];
				int col2c=snes_image[(y*2)*256+(x*2+1)];
				int col2d=snes_image[(y*2+1)*256+(x*2+1)];									
				int col2;
				col2=((((((col2a>>10)&31)+((col2b>>10)&31)+((col2c>>10)&31)+((col2d>>10)&31))>>2)*2/3)<<10);
				col2|=((((((col2a>>5)&31)+((col2b>>5)&31)+((col2c>>5)&31)+((col2d>>5)&31))>>2)*2/3)<<5);
				col2|=((((((col2a>>0)&31)+((col2b>>0)&31)+((col2c>>0)&31)+((col2d>>0)&31))>>2)*2/3)<<0);
				os9x_savestate_mini[y*128+x]=col2;
			}		
		WRITE_STREAM(os9x_savestate_mini,128*120*2,*file);
	}
  return (true);
}

void S9xCloseSnapshotFile (STREAM file) {		
  CLOSE_STREAM (file);
}

extern "C" {

int os9x_getstate(char *ext,char *str_time) {
	STREAM file;
	const char *save_filename;		
	SceIoStat stat;
	ScePspDateTime *tfile;
	
	save_filename=S9xGetSaveFilename (ext);		
	if (sceIoGetstat(save_filename,&stat)>=0) {
			tfile=&(stat.st_mtime);	
			sprintf(str_time,"%4d/%02d/%02d %02d:%02d:%02d",tfile->year,tfile->month,tfile->day,
			tfile->hour,tfile->minute,tfile->second);
			S9xOpenSnapshotFile(save_filename,1,&file);
			S9xCloseSnapshotFile(file);								
			return 1;
	}				
	return 0;
}
	
void load_background(){	
	sprintf(str_tmp,"%slogo.bmp",LaunchDir);
	FILE *fd = fopen(str_tmp,"rb");
	if (fd==NULL) {		
		debug_log("can't load\n");
		bg_img=NULL;
		return;
	}			
	bg_img = load_bmp(fd);
	fclose(fd);
	}

void show_background(int fade){	
		if (bg_img) image_put((SCREEN_WIDTH-bg_img->width)/2,(SCREEN_HEIGHT-bg_img->height)/2,bg_img,fade);	
		else pgFillvram(0);	
	}



void show_message() {
#define BLANK_LINES 25	
		char *decrypted_message,*p;
		int message_size;		
		char **msg_lines;
		int i,j,lines,pos;
		
		message_size=sizeof(message);
		decrypted_message=(char*)malloc(message_size+1);
		memcpy(decrypted_message,message,message_size);
		
		//prepare message to be diplayed
		
		p=decrypted_message;
		p[message_size]=0;		
		// 'lineify' it
		lines=0;		
		while (*p) {
			i=0;
			//get new line
			while ((p[i]!=0x0D)&&(p[i])) i++;			
			//if line carriage return, skip it & put a '0' / end of string 
			if (p[i]==0x0D) {
				p[i]=0;p[i+1]=0; //0x0D 0x0A
				i+=2;
			}
			lines++;
			p=p+i;
		}
		
		lines+=BLANK_LINES;
		msg_lines=(char**)malloc(sizeof(char*)*lines);
		for (i=0;i<BLANK_LINES ;i++) {
			msg_lines[i]=NULL;
		}
		p=decrypted_message;
		for (i=BLANK_LINES ;i<lines;i++){			
			msg_lines[i]=(char*)malloc(strlen(p)+1);
			strcpy(msg_lines[i],p);
			p=p+strlen(p)+2;
		}
		//free decrypted raw message
		free(decrypted_message);
		
		//now show messages & ask to scroll until the end
		pos=0;
		int exit_message=0;
		while (!exit_message) {
			show_background(192);
			for (i=0;((i+(pos/8))<lines)&&(i<34);i++) if (msg_lines[i+(pos/8)]) {
				if ((i+pos/8)<(lines-2)) pgPrintCenterY(i*8+(7^(pos&7)),0xffff,msg_lines[i+(pos/8)]);
				else if ((i+pos/8)==(lines-2)) pgPrintCenterY(i*8+(7^(pos&7)),10|(31<<5)|(10<<10),msg_lines[i+(pos/8)]);
				else pgPrintCenterY(i*8+(7^(pos&7)),31|(10<<5)|(10<<10),msg_lines[i+(pos/8)]);
			}
			if (lines>34){
				int h=219;
				int xpos=463;
				pgDrawFrame(xpos,25,xpos+1,243,(0xd<<0)|(0xd<<5)|(0x17<<10));
				pgFillBox(xpos+3, h*pos/(lines*8) + 25,xpos+15, h*(pos+34*8)/(lines*8) + 25,
					(0xd<<0)|(0xd<<5)|(0x17<<10));
				pgFillBox(xpos+4, h*pos/(lines*8) + 25+1,xpos+15-1, h*(pos+34*8)/(lines*8) + 25 -1,
					(0x17<<0)|(0x17<<5)|(0x1f<<10));
			}
			
			pgScreenFlipV();			
			 
			for (;;) {
				while (!(j=get_pad())) pgWaitV();					
				if ((j&PSP_CTRL_DOWN)&&(pos<(lines+1)*8-272)) {pos+=3;break;}
				if ((j&PSP_CTRL_UP)&&(pos>=3)) {pos-=3;break;}
				if (pos>=((lines+1)*8-272)) { //reached the end of message
					if (j&(PSP_CTRL_CIRCLE|PSP_CTRL_CROSS)) {exit_message=1;break;}
					if (j&(PSP_CTRL_TRIANGLE|PSP_CTRL_SQUARE|PSP_CTRL_SQUARE|PSP_CTRL_LTRIGGER|PSP_CTRL_RTRIGGER)) ExitCallback(0,0,NULL);
				}
			}			
		}
		while (get_pad()) pgWaitV();
								
		//free 'linified' message
		for (i=0;i<lines;i++) if (msg_lines[i]) free(msg_lines[i]);
		free(msg_lines);	
}

void checkdirs() { //check for need dirs & create them if needed
	int fd;
	char path[256];
	sprintf(path,"%sSAVES",LaunchDir);
	fd = sceIoDopen(path);
	if (fd<0) {			
		sceIoMkdir(path, 0777);
	} else {sceIoDclose(fd);}
}

void initvar_withdefault() {
	os9x_BG0=1;
	os9x_BG1=1;
	os9x_BG2=1;
	os9x_BG3=1;
	os9x_OBJ=1;
	os9x_easy=0;
	os9x_render=1;
	os9x_showfps=0;
	psp_vsync=0;
	os9x_cpuclock=222;
	os9x_apuenabled=2;
	os9x_gammavalue=0;
	os9x_fastsprite=0;	
	os9x_softrendering=3;
	os9x_smoothing=1;
	os9x_fskipvalue=1;//AUTO_FSKIP;	
	os9x_speedlimit=1;
	os9x_analog_mode=0;
	
	os9x_sndfreq = 44100;
	/** not in menu at the moment **/
	os9x_ShowSub=0;
	os9x_specialskipframe=0;
	os9x_CyclesPercentage=100;	
	os9x_DisableHDMA=0;
	os9x_DisableIRQ=0;
	
	strcpy(romPath,LaunchDir);
	lastRom[0]=0;
}

int PspDebugPrintHandler_std(const char *data, int len) {
	/* Do normal initial dump, setup screen etc */
	pspDebugScreenInit();

	/* I always felt BSODs were more interesting that white on black */
	pspDebugScreenSetBackColor(0x00FF0000);
	pspDebugScreenSetTextColor(0xFFFFFFFF);
	pspDebugScreenClear();
	
	pspDebugScreenPrintf(data);			
	return 0;
}

/*
void MyExceptionHandler(PspDebugRegBlock *regs)
{
	// Do normal initial dump, setup screen etc 
	pspDebugScreenInit();

	// I always felt BSODs were more interesting that white on black 
	pspDebugScreenSetBackColor(0x00FF0000);
	pspDebugScreenSetTextColor(0xFFFFFFFF);
	pspDebugScreenClear();

	pspDebugScreenPrintf("I regret to inform you your psp has just crashed\n");
	pspDebugScreenPrintf("Please contact Sony technical support for further information\n\n");
	pspDebugScreenPrintf("Exception Details:\n");
	pspDebugDumpException(regs);
	pspDebugScreenPrintf("\nBlame the 3rd party software, it cannot possibly be our fault!\n");
}

__attribute__((constructor)) void loaderInit() { 
	pspKernelSetKernelPC();     
	pspDebugInstallStdoutHandler(PspDebugPrintHandler_std);
	pspDebugInstallStderrHandler(PspDebugPrintHandler_std);
	pspDebugInstallErrorHandler (MyExceptionHandler);
} 
*/

int main(int argc, char *argv[]) {

	SetupCallbacks();
	sceCtrlSetSamplingCycle( 0 );
	sceCtrlSetSamplingMode( PSP_CTRL_MODE_ANALOG );
	
	sceDisplaySetMode( 0, SCREEN_WIDTH, SCREEN_HEIGHT );
	sceDisplaySetFrameBuf( (char*)VRAM_ADDR, 512, 1, 1 );
	pgScreenFrame(2,0);	
	

	strncpy(LaunchDir,argv[0],sizeof(LaunchDir)-1);
	LaunchDir[sizeof(LaunchDir)-1]=0;
	char *str_ptr=strrchr(LaunchDir,'/');
	if (str_ptr){
		str_ptr++;
		*str_ptr=0;
	}
		
	checkdirs();
	initvar_withdefault();
	if (!bypass_loadsettings) load_settings();
	
	InitFiler("[" EMUNAME_VERSION "] - Choose a ROM file",romPath);
	load_background();
	in_emu=0;	
	os9x_padvalue=0;
	os9x_padvalue_ax=0x80;
	os9x_padvalue_ay=0x80;
	
	{
		char str[256];
		int show_msg=1;
		SceIoStat stat;
		ScePspDateTime *tfile;
						
		sprintf(str,"%s%s",LaunchDir,"snes9xTYL.ini");
		if (sceIoGetstat(str,&stat)>=0) {
			tfile=&(stat.st_mtime);	
			time_t cur_time;
			struct tm *tsys;			
			sceKernelLibcTime(&cur_time);			
			tsys=localtime(&cur_time); 																		
			int diff=((tsys->tm_mday!=tfile->day)||(tsys->tm_mon+1!=tfile->month)||
							(tsys->tm_year+1900!=tfile->year));
			if (!diff) show_msg=0;			
		}
		if (show_msg) show_message();
	}
	//pgScreenFrame(1,0);

		
	g_bSleep=0;	
	so.sound_fd = -1;
	memset( &Settings, 0, sizeof( Settings ) );
	// ROM Options
	Settings.SDD1Pack = true;
    Settings.ForceLoROM = false;
    Settings.ForceInterleaved = false;
    Settings.ForceNotInterleaved = false;
    Settings.ForceInterleaved = false;
    Settings.ForceInterleaved2 = false;
    Settings.ForcePAL = false;
    Settings.ForceNTSC = false;
    Settings.ForceHeader = false;
    Settings.ForceNoHeader = false;   
    // Sound options            
    Settings.SoundSync = 0;
    Settings.InterpolatedSound = true;
    Settings.SoundEnvelopeHeightReading = TRUE;
    Settings.DisableSoundEcho = FALSE;
    Settings.DisableMasterVolume = FALSE;
    Settings.Mute = FALSE;
    Settings.SoundSkipMethod = 0;
    Settings.SoundPlaybackRate = os9x_sndfreq;
    Settings.SixteenBitSound = true;
    Settings.Stereo = true;
    Settings.AltSampleDecode = 0;//os9x_sampledecoder;
    Settings.ReverseStereo = FALSE;
//    Settings.SoundDriver = 0;//WIN_SNES9X_DIRECT_SOUND_DRIVER;
    Settings.SoundBufferSize = 1024;//4;
    Settings.SoundMixInterval = 0;//20;
	Settings.DisableSampleCaching=TRUE;
	
	Settings.FixFrequency = FALSE;

    // Tracing options
    Settings.TraceDMA = false;
    Settings.TraceHDMA = false;
    Settings.TraceVRAM = false;
    Settings.TraceUnknownRegisters = false;
    Settings.TraceDSP = false;

    // Joystick options
    Settings.SwapJoypads = false;
    Settings.JoystickEnabled = false;

    // ROM timing options (see also H_Max above)
    Settings.PAL = false;
    Settings.FrameTimePAL = 20;
    Settings.FrameTimeNTSC = 17;    

    // CPU options 
    Settings.CyclesPercentage = os9x_CyclesPercentage;
    Settings.Shutdown = true;
    Settings.ShutdownMaster = true;
    Settings.NextAPUEnabled = Settings.APUEnabled = os9x_apuenabled;
    Settings.DisableIRQ = os9x_DisableIRQ;
    Settings.Paused = false;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
    
    os9x_specialskipframe=0;
    if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
    else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
    {
    	Settings.SkipFrames=0;
    	os9x_specialskipframe=1;
    }
    else Settings.SkipFrames=os9x_fskipvalue;


    // ROM image and peripheral options
    Settings.ForceSuperFX = false;
    Settings.ForceNoSuperFX = false;
    Settings.MultiPlayer5 = true;
    Settings.Mouse = true;
    Settings.SuperScope = true;
    Settings.MultiPlayer5Master = true;
    Settings.SuperScopeMaster = true;
    Settings.MouseMaster = true;
    Settings.SuperFX = false;
 
    // SNES graphics options
    Settings.BGLayering = false;
    Settings.DisableGraphicWindows = false;
    Settings.ForceTransparency = false;
    Settings.ForceNoTransparency = false;
    Settings.DisableHDMA = os9x_DisableHDMA;
    Settings.Mode7Interpolate = false;
    Settings.DisplayFrameRate = false;
    
    Settings.SixteenBit = 1;
    Settings.Transparency = 1;
    Settings.SupportHiRes = false;

    Settings.AutoSaveDelay = 0;
    Settings.ApplyCheats = true;

    Settings.TurboMode = false;
    Settings.TurboSkipFrames = 15;
    Settings.AutoMaxSkipFrames = 10;

    Settings.Port = 1996;


  Settings.ForcedPause = 0;
  Settings.StopEmulation = TRUE;
  Settings.Paused = FALSE;       
  Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
    

  if ( !Memory.Init() || !S9xInitAPU() ) {
		return -1;
	}


	S9xInitSound( Settings.SoundPlaybackRate, Settings.Stereo, Settings.SoundBufferSize );	
	S9xSetSoundMute( TRUE );
	

	uint32 saved_flags = CPU.Flags;


	pgFillAllvram(0);
	pgScreenFrame(2,0);	
	
	
#ifdef __DEBUG_SNES_
	sprintf(rom_filename,__DEBUG__ROM__);
	strcpy(LastPath,"ms0:/PSP/GAME/snes9xTYL/");
#else
	strcpy(rom_filename,lastRom);	
	getFilePath(rom_filename,0);
	strcpy(lastRom,os9x_shortfilename(rom_filename));
	strcpy(romPath,LastPath);
#endif	
	
	pgFillAllvram(0);
	//pgScreenFlipV();
	//pgScreenFrame(1,0);	
	
	
	char *str=strrchr((const char *)rom_filename,'/');	
	if (!str) str=rom_filename;
  strcpy(shortrom_filename,str+1);
	debug_log(shortrom_filename);	  

	msgBox("Loading ROM...");
	if ( !Memory.LoadROM( rom_filename ) ){
		//debug_log( "LoadROM NG" );
		return -1;
	}
	//debug_log( S9xGetSaveFilename(".SRM") );
	Memory.LoadSRAM( (char*)S9xGetSaveFilename( ".SRM" ) );
	
	CPU.Flags = saved_flags;

	S9xInitInputDevices();

	S9xInitDisplay();
	if ( !S9xGraphicsInit() ){
		return -1;
	}
		
	s_iFrame = 0;
	sceKernelLibcGettimeofday( &s_tvStart, 0 );
	
	
	InitSoundThread();
	
	if (/*Settings.APUEnabled*/os9x_apuenabled==2){
		S9xSetSoundMute( false );
	}
			
	in_emu=1;			
	
#ifdef __DEBUG_SNES_	
	os9x_load(DEBUG_SAVE_SLOT);	
#endif	
	
	blit_init();
	
	
	os9x_snesheight=(Settings.PAL?240:224);
	
	
	
	while ( g_bLoop ){
		if ( !Settings.Paused ){
			S9xMainLoop();
		}
		if (g_bSleep){
			while(g_bSleep) pgWaitV();
			set_cpu_clock();
			InitSoundThread();
			sceKernelLibcGettimeofday( &s_tvStart, 0 );
		}
		if (os9x_newrom){
			//save old rom sram if available						
			Memory.SaveSRAM( (char*)S9xGetSaveFilename(".SRM") );									
			before_pause();
			os9x_newrom=0;
			pgFillAllvram(0);
			pgScreenFrame(2,0);	
			strcpy(rom_filename,lastRom);
			if (getFilePath(rom_filename,1)==1){
				strcpy(lastRom,os9x_shortfilename(rom_filename));
				strcpy(romPath,LastPath);
				msgBox("Loading ROM...");
				if ( !Memory.LoadROM( rom_filename ) ){
					//debug_log( "LoadROM NG" );
					return -1;
				}
				//debug_log( S9xGetSaveFilename(".SRM") );
				Memory.LoadSRAM( (char*)S9xGetSaveFilename( ".SRM" ) );
				os9x_snesheight=(Settings.PAL?240:224);
			}
			after_pause();
		}
	}
	
	blit_shutdown();
		
	if (bg_img) image_free(bg_img);
	ExitCallback(0,0,NULL);	
	return 0;
}

int os9x_savesnap() {
	u16 *snes_image;
	if (os9x_softrendering<2)	snes_image=(u16*)(0x44000000+512*272*2*2);
	else snes_image=(u16*)(0x44000000+2*512*272*2+256*240*4+2*256*256*2);
	write_JPEG_file ((char*)S9xGetSaveFilename(".jpg"),75,snes_image,256,os9x_snesheight,256); 
	return 0;
}

int os9x_loadsnap(char *fname,u16 *snes_image,int *height) {	
	if (read_JPEG_file (fname,snes_image,256,240,256,height)) return 1;	
	return 0;
}

int os9x_savesram() {
	Memory.SaveSRAM( (char*)S9xGetSaveFilename(".SRM") );
	return 0;
}

int os9x_save(const char *ext)
{
	const char *save_filename;
	//pgScreenFrame(1,0);
	save_filename=S9xGetSaveFilename (ext);	
	msgBox((char*)save_filename);	
	S9xFreezeGame(save_filename);	
	return 0;
}



int os9x_load(const char *ext) {	
	FILE *savefile;
	const char *save_filename;
	
	//pgScreenFrame(1,0);	
	save_filename=S9xGetSaveFilename (ext);	
	savefile=fopen(save_filename,"rb");
  if (savefile) {
  	fclose(savefile);
		S9xUnfreezeGame(save_filename);
//		S9xInitUpdate();
		S9xReschedule ();
		return 1;
	} 
	return 0;
}


int os9x_loadzsnes(char *ext) {	
	FILE *savefile;
	const char *save_filename;
	
	//pgScreenFrame(1,0);	
	save_filename=S9xGetSaveFilename (ext);	
	savefile=fopen(save_filename,"rb");
  if (savefile) {
 		fclose(savefile);		
		S9xUnfreezeGame(save_filename);
//		S9xInitUpdate();
		S9xReschedule ();
		return 1;
	}
	return 0;
}

char *os9x_shortfilename(char *filename){
	static char fname [256];
	char drive [_MAX_DRIVE + 1];
	char dir [_MAX_DIR + 1];	
	char ext [_MAX_EXT + 1];
	_splitpath (filename, drive, dir, fname, ext);
	strcat(fname,".");
	strcat(fname,ext);
	return fname;
}

void msgBox(char *msg) {
	int len=strlen(msg)*8;
	pgFillBox(240-len/2-20-1,136-10-1,240+len/2+20+1,136+18+1,(16<<10)|(10<<5)|7);
	pgDrawFrame(240-len/2-20,136-10,240+len/2+20,136+18,(12<<10)|(8<<5)|5);
	pgPrintCenter(17,(15<<10)|(31<<5)|31,msg);
	pgScreenFlipV();
	pgWaitVn(20);
}

int inputBox(char *msg) {
	int len=strlen(msg)*8;
	int pad;
	pgFillBox(240-len/2-20-1,136-24-1,240+len/2+20+1,136+30+1,(16<<10)|(10<<5)|7);
	pgDrawFrame(240-len/2-20,136-24,240+len/2+20,136+30,(12<<10)|(8<<5)|5);
	pgPrintCenter(16,(15<<10)|(31<<5)|31,msg);
	pgPrintCenter(18,(31<<10)|(31<<5)|31,"\1 OK, \2 CANCEL");
	pgScreenFlipV();			
	while (get_pad()) pgWaitV();
	while (1){
		pad=get_pad();
		if (pad) while (get_pad()) pgWaitV();
		if (pad&PSP_CTRL_CIRCLE) return 1;			
		if (pad&PSP_CTRL_CROSS) return 0;
	}
}

}
